config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  devise_for :users, controllers: {
    confirmations: "users/confirmations",
    omniauth_callbacks: "users/omniauth_callbacks",
    passwords: "users/passwords",
    registrations: "users/registrations",
    sessions: "users/sessions",
    unlocks: "users/unlocks"
  }

  root to: "home#index"

  resources :documents do
    resource :outline, only: %i[show], controller: "documents/outline"
  end
end

app/controllers/home_controller.rb
# frozen_string_literal: true

class HomeController < ApplicationController
  before_action :authenticate_user!

  def index
    @documents = current_user.documents
                             .accessible_by(current_ability)
                             .order(:updated_at, :desc)
                             .limit(9)
  end
end

app/helpers/homes_helper.rb
# frozen_string_literal: true

module HomesHelper
end

app/views/home/index.html.erb
<div class="flex min-w-0 flex-1 flex-col overflow-hidden">
  <main class="flex flex-1 overflow-hidden">
    <div class="flex flex-1 flex-col overflow-y-auto xl:overflow-hidden">
      <nav aria-label="Breadcrumb" class="border-b border-orange-gray-200 bg-white">
        <div class="mx-auto flex max-w-3xl items-start py-3 px-4 sm:px-6 lg:px-8">
          <span class="text-sm">&nbsp;</span>
        </div>
      </nav>

      <% if @documents.empty? %>
        <div class="flex flex-1 place-content-center xl:overflow-hidden">
          <div class="flex items-center m-4 space-x-4">
            <p class="text-gray-500">You have not worked on any documents yet. Create one now!</p>
            <%= button_to "New document", documents_path, method: :post, class: "inline-flex items-center rounded-md border border-transparent bg-orange-600 px-4 py-2 text-sm font-medium text-white shadow-sm hover:bg-orange-700 focus:outline-none focus:ring-2 focus:ring-orange-500 focus:ring-offset-2" %>
          </div>
        </div>
      <% else %>
        <div class="flex p-4">
          <ul role="list" class="grid grid-cols-1 gap-6 sm:grid-cols-2 lg:grid-cols-3">
            <li class="col-span-1 bg-purple-400 hover:bg-purple-500 transition duration-100 ease-in-out rounded-sm bg-white shadow">
              <%= button_to documents_path, class: "flex text-white font-medium items-center p-6", method: :post do %>
                New document
              <% end %>
            </li>
            <% @documents.each do |document| %>
              <li class="col-span-1 rounded-sm bg-white shadow">
                <%= link_to document, class: "block divide-y divide-gray-200" do %>
                  <div class="flex w-full items-center justify-between space-x-6 p-6">
                    <%= document.title %>
                  </div>
                  <div class="px-6 py-2">
                    <span class="text-xs text-gray-400">
                      Created <time datetime="<%= document.created_at %>"><%= time_ago_in_words document.created_at %></time> ago.
                    </span>
                  </div>
                <% end %>
              </li>
            <% end %>
          </ul>
        </div>
      <% end %>
    </div>
  </main>
</div>